

   MEMBER('CsvArrayTest.clw')                              ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

!!! <summary>
!!! Generated from procedure template - Frame
!!! CsvArray.dct
!!! </summary>
Main PROCEDURE 

AppFrame             APPLICATION('CSV Array Import Example'),AT(,,600,350),FONT('Microsoft Sans Serif',8,,FONT:regular, |
  CHARSET:DEFAULT),RESIZE,CENTER,ICON('WAFRAME.ICO'),MAX,STATUS(-1,80,120,45),SYSTEM,IMM
                       MENUBAR,USE(?Menubar)
                         MENU('&File'),USE(?FileMenu)
                           ITEM('&Print Setup ...'),USE(?PrintSetup),MSG('Setup printer'),STD(STD:PrintSetup)
                           ITEM,USE(?SEPARATOR1),SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
                         END
                         MENU('&Edit'),USE(?EditMenu)
                           ITEM('Cu&t'),USE(?Cut),MSG('Cut Selection To Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy Selection To Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste From Clipboard'),STD(STD:Paste)
                         END
                         MENU('&Browse'),USE(?BrowseMenu)
                           ITEM('Browse the CsvArray file'),USE(?BrowseCsvArray),MSG('Browse CsvArray')
                         END
                         MENU('&Window'),USE(?WindowMenu),STD(STD:WindowList)
                           ITEM('T&ile'),USE(?Tile),MSG('Arrange multiple opened windows'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Arrange multiple opened windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Arrange the icons for minimized windows'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),USE(?HelpMenu)
                           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('Provides general instructions on using help'), |
  STD(STD:HelpOnHelp)
                         END
                       END
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
Menu::Menubar ROUTINE                                      ! Code for menu items on ?Menubar
Menu::FileMenu ROUTINE                                     ! Code for menu items on ?FileMenu
Menu::EditMenu ROUTINE                                     ! Code for menu items on ?EditMenu
Menu::BrowseMenu ROUTINE                                   ! Code for menu items on ?BrowseMenu
  CASE ACCEPTED()
  OF ?BrowseCsvArray
    START(BrowseCsvArray, 050000)
  END
Menu::WindowMenu ROUTINE                                   ! Code for menu items on ?WindowMenu
Menu::HelpMenu ROUTINE                                     ! Code for menu items on ?HelpMenu

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(AppFrame)                                      ! Open window
  Do DefineListboxStyle
  SELF.SetAlerts()
      AppFrame{PROP:TabBarVisible}  = False
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    ELSE
      DO Menu::Menubar                                     ! Process menu items on ?Menubar menu
      DO Menu::FileMenu                                    ! Process menu items on ?FileMenu menu
      DO Menu::EditMenu                                    ! Process menu items on ?EditMenu menu
      DO Menu::BrowseMenu                                  ! Process menu items on ?BrowseMenu menu
      DO Menu::WindowMenu                                  ! Process menu items on ?WindowMenu menu
      DO Menu::HelpMenu                                    ! Process menu items on ?HelpMenu menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the CsvArray file
!!! </summary>
BrowseCsvArray PROCEDURE 

CurrentTab           STRING(80)                            ! 
BRW1::View:Browse    VIEW(CsvArray)
                       PROJECT(CsvA:Cell)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
CsvA:Cell_1            STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_2            STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_3            STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_4            STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_5            STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_6            STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_7            STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_8            STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_9            STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_10           STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_11           STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_12           STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_13           STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_14           STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_15           STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_16           STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_17           STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_18           STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_19           STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_20           STRING(256)                    !List box control field - type derived from field (Array Component)
CsvA:Cell_21           STRING(256)                    !List box control field - type derived from field (Array Component)
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the CsvArray file'),AT(,,514,223),FONT('Microsoft Sans Serif',8,,FONT:regular, |
  CHARSET:DEFAULT),RESIZE,GRAY,IMM,MDI,HLP('BrowseCsvArray'),SYSTEM
                       LIST,AT(7,9,501,183),USE(?Browse:1),HVSCROLL,FORMAT('50L(2)|M~1~C(0)@s255@50L(2)|M~2~C(' & |
  '0)@s255@50L(2)|M~3~C(0)@s255@50L(2)|M~4~C(0)@s255@50L(2)|M~5~C(0)@s255@50L(2)|M~6~C(' & |
  '0)@s255@50L(2)|M~7~C(0)@s255@50L(2)|M~8~C(0)@s255@50L(2)|M~9~C(0)@s255@50L(2)|M~10~C' & |
  '(0)@s255@50L(2)|M~11~C(0)@s255@50L(2)|M~12~C(0)@s255@50L(2)|M~13~C(0)@s255@50L(2)|M~' & |
  '14~C(0)@s255@50L(2)|M~15~C(0)@s255@50L(2)|M~16~C(0)@s255@50L(2)|M~17~C(0)@s255@50L(2' & |
  ')|M~18~C(0)@s255@50L(2)|M~19~C(0)@s255@50L(2)|M~20~C(0)@s255@50L(2)|M~21~C(0)@s255@'),FROM(Queue:Browse:1), |
  IMM
                       BUTTON('&View'),AT(8,199,49,14),USE(?View:2),LEFT,ICON('WAVIEW.ICO'),FLAT,MSG('View Record'), |
  TIP('View Record')
                       BUTTON('&Change'),AT(61,199,49,14),USE(?Change:3),LEFT,ICON('WACHANGE.ICO'),DEFAULT,DISABLE, |
  FLAT,MSG('Change the Record'),TIP('Change the Record')
                       BUTTON('&Close'),AT(452,199,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:StepClass StepClass                            ! Default Step Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
? DEBUGHOOK(CsvArray:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseCsvArray')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('CsvA:Cell_1',CsvA:Cell[1])                         ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_2',CsvA:Cell[2])                         ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_3',CsvA:Cell[3])                         ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_4',CsvA:Cell[4])                         ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_5',CsvA:Cell[5])                         ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_6',CsvA:Cell[6])                         ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_7',CsvA:Cell[7])                         ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_8',CsvA:Cell[8])                         ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_9',CsvA:Cell[9])                         ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_10',CsvA:Cell[10])                       ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_11',CsvA:Cell[11])                       ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_12',CsvA:Cell[12])                       ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_13',CsvA:Cell[13])                       ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_14',CsvA:Cell[14])                       ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_15',CsvA:Cell[15])                       ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_16',CsvA:Cell[16])                       ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_17',CsvA:Cell[17])                       ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_18',CsvA:Cell[18])                       ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_19',CsvA:Cell[19])                       ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_20',CsvA:Cell[20])                       ! Added by: BrowseBox(ABC)
  BIND('CsvA:Cell_21',CsvA:Cell[21])                       ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:CsvArray.Open                                     ! File CsvArray used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:CsvArray,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.AddSortOrder(,)                                     ! Add the sort order for  for sort order 1
  BRW1.AddField(CsvA:Cell[1],BRW1.Q.CsvA:Cell_1)           ! Field CsvA:Cell[1] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[2],BRW1.Q.CsvA:Cell_2)           ! Field CsvA:Cell[2] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[3],BRW1.Q.CsvA:Cell_3)           ! Field CsvA:Cell[3] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[4],BRW1.Q.CsvA:Cell_4)           ! Field CsvA:Cell[4] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[5],BRW1.Q.CsvA:Cell_5)           ! Field CsvA:Cell[5] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[6],BRW1.Q.CsvA:Cell_6)           ! Field CsvA:Cell[6] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[7],BRW1.Q.CsvA:Cell_7)           ! Field CsvA:Cell[7] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[8],BRW1.Q.CsvA:Cell_8)           ! Field CsvA:Cell[8] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[9],BRW1.Q.CsvA:Cell_9)           ! Field CsvA:Cell[9] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[10],BRW1.Q.CsvA:Cell_10)         ! Field CsvA:Cell[10] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[11],BRW1.Q.CsvA:Cell_11)         ! Field CsvA:Cell[11] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[12],BRW1.Q.CsvA:Cell_12)         ! Field CsvA:Cell[12] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[13],BRW1.Q.CsvA:Cell_13)         ! Field CsvA:Cell[13] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[14],BRW1.Q.CsvA:Cell_14)         ! Field CsvA:Cell[14] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[15],BRW1.Q.CsvA:Cell_15)         ! Field CsvA:Cell[15] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[16],BRW1.Q.CsvA:Cell_16)         ! Field CsvA:Cell[16] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[17],BRW1.Q.CsvA:Cell_17)         ! Field CsvA:Cell[17] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[18],BRW1.Q.CsvA:Cell_18)         ! Field CsvA:Cell[18] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[19],BRW1.Q.CsvA:Cell_19)         ! Field CsvA:Cell[19] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[20],BRW1.Q.CsvA:Cell_20)         ! Field CsvA:Cell[20] is a hot field or requires assignment from browse
  BRW1.AddField(CsvA:Cell[21],BRW1.Q.CsvA:Cell_21)         ! Field CsvA:Cell[21] is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  BRW1.AskProcedure = 1                                    ! Will call: UpdateCsvArray
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:CsvArray.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  Request = ViewRecord
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateCsvArray
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.ChangeControl=?Change:3
  END
  SELF.ViewControl = ?View:2                               ! Setup the control used to initiate view only mode


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form CsvArray
!!! </summary>
UpdateCsvArray PROCEDURE 

CurrentTab           STRING(80)                            ! 
ActionMessage        CSTRING(40)                           ! 
History::CsvA:Record LIKE(CsvA:RECORD),THREAD
QuickWindow          WINDOW('Form CsvArray'),AT(,,340,210),FONT('Microsoft Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  GRAY,IMM,MDI,HLP('UpdateCsvArray'),SYSTEM
                       BUTTON('&OK'),AT(117,177,49,18),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT
                       BUTTON('&Cancel'),AT(174,177,49,18),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation')
                       PROMPT('Cell 1 :'),AT(9,10),USE(?CsvA:Cell:Pmt01)
                       PROMPT('Cell 2 :'),AT(9,20),USE(?CsvA:Cell:Pmt02)
                       PROMPT('Cell 3 :'),AT(9,30),USE(?CsvA:Cell:Pmt03)
                       PROMPT('Cell 4 :'),AT(9,40),USE(?CsvA:Cell:Pmt04)
                       PROMPT('Cell 5 :'),AT(9,50),USE(?CsvA:Cell:Pmt05)
                       PROMPT('Cell 6 :'),AT(9,60),USE(?CsvA:Cell:Pmt06)
                       PROMPT('Cell 7 :'),AT(9,70),USE(?CsvA:Cell:Pmt07)
                       PROMPT('Cell 8 :'),AT(9,80),USE(?CsvA:Cell:Pmt08)
                       PROMPT('Cell 9 :'),AT(9,90),USE(?CsvA:Cell:Pmt09)
                       PROMPT('Cell 10:'),AT(9,100),USE(?CsvA:Cell:Pmt10)
                       PROMPT('Cell 11:'),AT(9,110),USE(?CsvA:Cell:Pmt11)
                       PROMPT('Cell 12:'),AT(9,120),USE(?CsvA:Cell:Pmt12)
                       PROMPT('Cell 13:'),AT(9,130),USE(?CsvA:Cell:Pmt13)
                       PROMPT('Cell 14:'),AT(9,140),USE(?CsvA:Cell:Pmt14)
                       PROMPT('Cell 15:'),AT(9,150),USE(?CsvA:Cell:Pmt15)
                       PROMPT('Cell 16:'),AT(9,160),USE(?CsvA:Cell:Pmt16)
                       ENTRY(@s255),AT(38,10,289,10),USE(CsvA:Cell[1])
                       ENTRY(@s255),AT(38,20,289,10),USE(CsvA:Cell[2])
                       ENTRY(@s255),AT(38,30,289,10),USE(CsvA:Cell[3])
                       ENTRY(@s255),AT(38,40,289,10),USE(CsvA:Cell[4])
                       ENTRY(@s255),AT(38,50,289,10),USE(CsvA:Cell[5])
                       ENTRY(@s255),AT(38,60,289,10),USE(CsvA:Cell[6])
                       ENTRY(@s255),AT(38,70,289,10),USE(CsvA:Cell[7])
                       ENTRY(@s255),AT(38,80,289,10),USE(CsvA:Cell[8])
                       ENTRY(@s255),AT(38,90,289,10),USE(CsvA:Cell[9])
                       ENTRY(@s255),AT(38,100,289,10),USE(CsvA:Cell[10])
                       ENTRY(@s255),AT(38,110,289,10),USE(CsvA:Cell[11])
                       ENTRY(@s255),AT(38,120,289,10),USE(CsvA:Cell[12])
                       ENTRY(@s255),AT(38,130,289,10),USE(CsvA:Cell[13])
                       ENTRY(@s255),AT(38,140,289,10),USE(CsvA:Cell[14])
                       ENTRY(@s255),AT(38,150,289,10),USE(CsvA:Cell[15])
                       ENTRY(@s255),AT(38,160,289,10),USE(CsvA:Cell[16])
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
? DEBUGHOOK(CsvArray:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    GlobalErrors.Throw(Msg:InsertIllegal)
    RETURN
  OF ChangeRecord
    GlobalErrors.Throw(Msg:UpdateIllegal)
    RETURN
  OF DeleteRecord
    GlobalErrors.Throw(Msg:DeleteIllegal)
    RETURN
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateCsvArray')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?OK
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(CsvA:Record,History::CsvA:Record)
  SELF.AddUpdateFile(Access:CsvArray)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:CsvArray.Open                                     ! File CsvArray used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:CsvArray
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.InsertAction = Insert:None                        ! Inserts not allowed
    SELF.DeleteAction = Delete:None                        ! Deletes not allowed
    SELF.ChangeAction = Change:None                        ! Changes not allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?CsvA:Cell_1{PROP:ReadOnly} = True
    ?CsvA:Cell_2{PROP:ReadOnly} = True
    ?CsvA:Cell_3{PROP:ReadOnly} = True
    ?CsvA:Cell_4{PROP:ReadOnly} = True
    ?CsvA:Cell_5{PROP:ReadOnly} = True
    ?CsvA:Cell_6{PROP:ReadOnly} = True
    ?CsvA:Cell_7{PROP:ReadOnly} = True
    ?CsvA:Cell_8{PROP:ReadOnly} = True
    ?CsvA:Cell_9{PROP:ReadOnly} = True
    ?CsvA:Cell_10{PROP:ReadOnly} = True
    ?CsvA:Cell_11{PROP:ReadOnly} = True
    ?CsvA:Cell_12{PROP:ReadOnly} = True
    ?CsvA:Cell_13{PROP:ReadOnly} = True
    ?CsvA:Cell_14{PROP:ReadOnly} = True
    ?CsvA:Cell_15{PROP:ReadOnly} = True
    ?CsvA:Cell_16{PROP:ReadOnly} = True
  END
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:CsvArray.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?OK
      ThisWindow.Update()
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

