  MEMBER('CsvArrayTest.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
CsvArrayTest_BC0:DctInit    PROCEDURE()
CsvArrayTest_BC0:DctKill    PROCEDURE()
CsvArrayTest_BC0:FilesInit  PROCEDURE()
  END

Hide:Access:CsvArray CLASS(FileManager),TYPE               ! FileManager for CsvArray
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:CsvArray CLASS(RelationManager),TYPE           ! RelationManager for CsvArray
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


_Hide:Access:CsvArray &Hide:Access:CsvArray,AUTO,THREAD
_Hide:Relate:CsvArray &Hide:Relate:CsvArray,AUTO,THREAD


CsvArrayTest_BC0:DctInit PROCEDURE()
  CODE
  _Hide:Access:CsvArray &= NEW(Hide:Access:CsvArray)
  _Hide:Relate:CsvArray &= NEW(Hide:Relate:CsvArray)
  Relate:CsvArray &= _Hide:Relate:CsvArray


CsvArrayTest_BC0:FilesInit PROCEDURE()
  CODE
  _Hide:Relate:CsvArray.Init


CsvArrayTest_BC0:DctKill PROCEDURE()
  CODE
  _Hide:Relate:CsvArray.Kill
  DISPOSE(_Hide:Relate:CsvArray)


Hide:Relate:CsvArray.Init PROCEDURE()
  CODE
  _Hide:Access:CsvArray.Init
  SELF.Init(Access:CsvArray,1)


Hide:Access:CsvArray.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= CsvA:Record
  SELF.FileNameValue = 'CsvArray'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= CsvArray
  PARENT.Init
  Access:CsvArray &= SELF


Hide:Access:CsvArray.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:CsvArray &= NULL                                  ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:CsvArray.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(CsvArray,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:CsvArray.Kill PROCEDURE

  CODE
  _Hide:Access:CsvArray.Kill                               ! Kill the file manager
  PARENT.Kill
  Relate:CsvArray &= NULL                                  ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:CsvArray)                           ! destroy the file manager

